#ident "@(#)$Header: ftw.h,v 1.6 93/08/13 10:50:54 jd Exp $ SNI"
/*
 * "@(#)ftw.h	Revision: 2.1	91/03/24 12:30:42"
 */
/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*#ident	"@(#)head:ftw.h	1.3.1.9"*/
/*
 *	Codes for the third argument to the user-supplied function
 *	which is passed as the second argument to ftwalk
 */

#ifndef _FTW_H
#define _FTW_H

#define	FTW_F	0	/* file */
#define	FTW_D	1	/* directory */
#define	FTW_DNR	2	/* directory without read permission */
#define	FTW_NS	3	/* unknown type, stat failed */
#define FTW_SL	4	/* symbolic link */
#define	FTW_DP	6	/* directory */
#define FTW_SLN	7	/* symbolic link that points to nonexistent file */

/*
 *	Codes for the fourth argument to ftwalk.  You can specify the
 *	union of these flags.
 */

#define FTW_PHYS	01  /* use lstat instead of stat */
#define FTW_MOUNT	02  /* do not cross a mount point */
#define FTW_CHDIR	04  /* chdir to each directory before reading */
#define FTW_DEPTH	010 /* call descendents before calling the parent */

#if !defined(_XOPEN_SOURCE)
struct FTW
{
	int	quit;
	int	base;
	int	level;
};
#endif /* !defined(_XOPEN_SOURCE) */

/*
 * legal values for quit
 */

#define FTW_SKD		1
#define FTW_FOLLOW	2
#define FTW_PRUNE	4

#if defined(__STDC__)

#include <sys/types.h>
#include <sys/stat.h>

#if	defined(_STYPES)
#if !defined(_STYPES)
static
#else
extern
#endif
int ftw(const char *, int (*)(const char *, const struct stat *, int), int);
#endif
#if !defined(_XOPEN_SOURCE)
extern int _xftw(const int, const char *, int (*)(const char *, const struct stat *, int), int);
#endif /* !defined(_XOPEN_SOURCE) */
#if     !defined(_STYPES) && !defined(_XOPEN_SOURCE)
#if defined(_STYPES)
static
#else
extern
#endif
int nftw(const char *, int (*)(const char *, const struct stat *, int, struct FTW *), int, int);
#endif

#else

#if	defined(_STYPES)
extern int ftw();
#endif
#if !defined(_XOPEN_SOURCE)
extern int _xftw();
#endif /* !defined(_XOPEN_SOURCE) */
#if     !defined(_STYPES) && !defined(_XOPEN_SOURCE)
#if defined(_STYPES)
static
#else
extern
#endif
int nftw();
#endif

#endif

#if !defined(_STYPES)

#define _XFTWVER 2      /* version of file tree walk */

static int ftw(__path, __fn, __depth)
const char *__path;
int (*__fn) ();
int __depth;
{
	return(_xftw(_XFTWVER, __path, __fn, __depth));
}
#endif

/* nftw not available to non-EFT applications */

#if defined(_STYPES)
#include <errno.h>

static int nftw(path, fn, depth, flags)
const char *path;
int (*fn) ();
int depth;
int flags;
{
	errno = EINVAL;
	return(-1);
}
#endif

#endif /* _FTW_H */
