#ident "@(#)$Header: tcp.h,v 1.9 93/12/03 12:32:26 try Exp $ SNI"
/*
 * "@(#)tcp.h	Revision: 2.2	91/06/05 09:53:29"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _NETINET_TCP_H
#define _NETINET_TCP_H

/*#ident "@(#)$Header: tcp.h,v 1.9 93/12/03 12:32:26 try Exp $ SNI"*/

/* #ident	"@(#)genneti:tcp.h	1.1" */

/*
 *  		PROPRIETARY NOTICE (Combined)
 *  
 *  This source code is unpublished proprietary information
 *  constituting, or derived under license from AT&T's Unix(r) System V.
 *  In addition, portions of such source code were derived from Berkeley
 *  4.3 BSD under license from the Regents of the University of
 *  California.
 *  
 *  
 *  
 *  		Copyright Notice 
 *  
 *  Notice of copyright on this source code product does not indicate 
 *  publication.
 *  
 *  	(c) 1986,1987,1988,1989  Sun Microsystems, Inc.
 *  	(c) 1983,1984,1985,1986,1987,1988,1989  AT&T.
 *  	          All rights reserved.
 */

/*
 * System V STREAMS TCP - Release 3.0 
 *
 * Copyright 1987, 1988, 1989 Lachman Associates, Incorporated (LAI) 
 * All Rights Reserved. 
 *
 * The copyright above and this notice must be preserved in all copies of this
 * source code.  The copyright above does not evidence any actual or intended
 * publication of this source code. 
 *
 * This is unpublished proprietary trade secret source code of Lachman
 * Associates.  This source code may not be copied, disclosed, distributed,
 * demonstrated or licensed except as expressly authorized by Lachman
 * Associates. 
 *
 * System V STREAMS TCP was jointly developed by Lachman Associates and
 * Convergent Technologies. 
 */

#define TCPOPEN		1
#define TCPCLOSEWAIT	2

typedef	u_long	tcp_seq;
/*
 * TCP header.
 * Per RFC 793, September, 1981.
 */
struct tcphdr {
	u_short	th_sport;		/* source port */
	u_short	th_dport;		/* destination port */
	tcp_seq	th_seq;			/* sequence number */
	tcp_seq	th_ack;			/* acknowledgement number */
#if defined(__vax__) || defined(__i386__)
	u_char	th_x2:4,		/* (unused) */
		th_off:4;		/* data offset */
#endif
#if defined(__mc68000__) || defined(__sparc__) || defined(u3b2) || defined(mips)
	u_char	th_off:4,		/* data offset */
		th_x2:4;		/* (unused) */
#endif
	u_char	th_flags;
#define	TH_FIN	0x01
#define	TH_SYN	0x02
#define	TH_RST	0x04
#define	TH_PUSH	0x08
#define	TH_ACK	0x10
#define	TH_URG	0x20
	u_short	th_win;			/* window */
	u_short	th_sum;			/* checksum */
	u_short	th_urp;			/* urgent pointer */
};

#define	TCPOPT_EOL	0
#define	TCPOPT_NOP	1
#define	TCPOPT_MAXSEG	2

/*
 * Default maximum segment size for TCP.
 * With an IP MSS of 576, this is 536,
 * but 512 is probably more convenient.
 */
#ifdef	lint
#define	TCP_MSS	536
#else
#ifndef IP_MSS
#define IP_MSS	576
#endif
#define	TCP_MSS	MIN(512, IP_MSS - sizeof (struct tcpiphdr))
#endif

#define	TCP_WINSIZE	8192	/* default window size for TCP */

/* 
 * SNI: additional macros to support increased window-sizes for
 * FDDI and Tokenring.
 */
#define TCP_M(x)		(min(x, 65535))

/* The minimum acceptable window for a given mss. */
#define TCP_WIN(mss)    	TCP_M(mss << 2)

/* Round a window size up to a mss size. */
#define TCP_ROUND(win, mss)	TCP_M(mss * ((win + mss - 1) / mss))

/*
 * XTI
 */
#ifndef _SYS_XTI_INET_H
#include <sys/xti_inet.h>
#endif /* _SYS_XTI_INET_H */

#endif	/* _NETINET_TCP_H */
