#ident "@(#)$Header: tcp_var.h,v 1.12 93/12/03 12:32:42 try Exp $ SNI"
/*
 * "@(#)tcp_var.h  Revision: 3.1   93/01/18 13:39:47" 
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _NETINET_TCP_VAR_H
#define _NETINET_TCP_VAR_H

/*#ident "@(#)$Header: tcp_var.h,v 1.12 93/12/03 12:32:42 try Exp $ SNI"*/

/* #ident	"@(#)kern-inet:tcp_var.h	1.1.4.1" */

/*
 *  		PROPRIETARY NOTICE (Combined)
 *  
 *  This source code is unpublished proprietary information
 *  constituting, or derived under license from AT&T's Unix(r) System V.
 *  In addition, portions of such source code were derived from Berkeley
 *  4.3 BSD under license from the Regents of the University of
 *  California.
 *  
 *  
 *  
 *  		Copyright Notice 
 *  
 *  Notice of copyright on this source code product does not indicate 
 *  publication.
 *  
 *  	(c) 1986,1987,1988,1989  Sun Microsystems, Inc.
 *  	(c) 1983,1984,1985,1986,1987,1988,1989  AT&T.
 *  	          All rights reserved.
 */

/*
 * System V STREAMS TCP - Release 3.0 
 *
 * Copyright 1987, 1988, 1989 Lachman Associates, Incorporated (LAI) 
 * All Rights Reserved. 
 *
 * The copyright above and this notice must be preserved in all copies of this
 * source code.  The copyright above does not evidence any actual or intended
 * publication of this source code. 
 *
 * This is unpublished proprietary trade secret source code of Lachman
 * Associates.  This source code may not be copied, disclosed, distributed,
 * demonstrated or licensed except as expressly authorized by Lachman
 * Associates. 
 *
 * System V STREAMS TCP was jointly developed by Lachman Associates and
 * Convergent Technologies. 
 */

/*
 * Kernel variables for tcp.
 */

/*
 * Tcp control block, one per tcp; fields:
 */
struct tcpcb {
	struct	tcpiphdr *seg_next;	/* sequencing queue */
#ifndef STRNET
	struct	tcpiphdr *seg_prev;
#endif
	short	t_state;		/* state of this connection */
	short	t_timer[TCPT_NTIMERS];	/* tcp timers */
	short	t_rxtshift;		/* log(2) of rexmt exp. backoff */
	short	t_rxtcur;		/* current retransmit value */
	short	t_dupacks;		/* consecutive dup acks recd */
	u_short	t_maxseg;		/* maximum segment size */
	char	t_force;		/* 1 if forcing out a byte */
	u_short	t_flags;
#define	TF_ACKNOW	0x01		/* ack peer immediately */
#define	TF_DELACK	0x02		/* ack, but try to delay it */
#define	TF_NODELAY	0x04		/* don't delay packets to coalesce */
#define	TF_NOOPT	0x08		/* don't use tcp options */
#define	TF_SENTFIN	0x10		/* have sent FIN */
#ifdef XTI_SUPPORT
	/*
	 * Send a garbage byte with keepalive packets. This is for
	 * compatibility with broken BSD4.2 implementations.
	 */
#define TF_GARBAGE      0x0200
#endif /* XTI_SUPPORT */
#ifdef STRNET
	u_short	t_gates;
#define TG_GATELOCK     0x01		/* gate is locked */
#define TG_NEEDIN       0x02		/* need input */
#define TG_NEEDOUT      0x04		/* need output */
#define	TG_NEEDSLTIMER	0x08  		/* need timer */
#define	TG_NEEDFSTIMER	0x10  		/* need timer */
#define TG_NEEDDEQDATA  0x20		/* need tcp_daqdata */
#define TG_NEEDDROP	0x40		/* need tcp_drop */
#define TG_NEEDERRDISCON 0x80		/* need tcp_errdiscon */
#define TG_NEEDCLOSE 	0x100		/* need tcpclosegate */
#define TG_NEEDTQ	0x200		/* need t_q & t_q0 processed */
#define TG_SUGO		0x400		/* need super go */
#define TG_NEEDMSG	0x800		/* need process messages */
#define TG_NEEDDISCONN	0x1000		/* need tcp_disconnect */
	mblk_t	*t_msgq;		/* message queue */
#endif /* STRNET */
	struct	tcpiphdr *t_template;	/* skeletal packet for transmit */
#ifdef STRNET
        mblk_t	*t_tmplhdr;		/* template back-pointer for dealloc */
#endif /* STRNET */
	struct	inpcb *t_inpcb;		/* back pointer to internet pcb */
/*
 * The following fields are used as in the protocol specification.
 * See RFC783, Dec. 1981, page 21.
 */
/* send sequence variables */
	tcp_seq	snd_una;		/* send unacknowledged */
	tcp_seq	snd_nxt;		/* send next */
	tcp_seq	snd_up;			/* send urgent pointer */
	tcp_seq	snd_wl1;		/* window update seg seq number */
	tcp_seq	snd_wl2;		/* window update seg ack number */
	tcp_seq	iss;			/* initial send sequence number */
	u_long	snd_wnd;		/* send window */
/* receive sequence variables */
	u_long	rcv_wnd;		/* receive window */
	tcp_seq	rcv_nxt;		/* receive next */
	tcp_seq	rcv_up;			/* receive urgent pointer */
	tcp_seq	irs;			/* initial receive sequence number */
/*
 * Additional variables for this implementation.
 */
/* receive variables */
	tcp_seq	rcv_adv;		/* advertised window */
/* retransmit variables */
	tcp_seq	snd_max;		/* highest sequence number sent
					 * used to recognize retransmits
					 */
	u_long	t_maxwin;		/* max window size to use */
/* congestion control (for slow start, source quench, retransmit after loss) */
	u_long	snd_cwnd;		/* congestion-controlled window */
	u_long	snd_ssthresh;		/* snd_cwnd size threshhold for
					 * for slow start exponential to
					 * linear switch */
/*
 * transmit timing stuff.
 * srtt and rttvar are stored as fixed point; for convenience in smoothing,
 * srtt has 3 bits to the right of the binary point, rttvar has 2.
 * "Variance" is actually smoothed difference.
 */
	short	t_idle;			/* inactivity time */
	short	t_rtt;			/* round trip time */
	tcp_seq	t_rtseq;		/* sequence number being timed */
	short	t_srtt;			/* smoothed round-trip time */
	short	t_rttvar;		/* variance in round-trip time */
	u_short max_rcvd;		/* most peer has sent into window */
	u_short	max_sndwnd;		/* largest window peer has offered */
/* out-of-band data */
	char	t_oobflags;		/* have some */
	char	t_iobc;			/* input character */
#define	TCPOOB_HAVEDATA	0x01
#define	TCPOOB_HADDATA	0x02
#ifdef STRNET
	struct	tcpcb *t_head;		/* back pointer to accept tcpcb */
	struct	tcpcb *t_q0;		/* queue of partial connections */
	struct	tcpcb *t_q;		/* queue of incoming connections */
	short	t_q0len;		/* partials on t_q0 */
	short	t_qlen;			/* number of connections on so_q */
	short	t_qlimit;		/* max number queued connections */
	/*
	 * We keep our own count of data on the queue rather than
	 * rely on q_count because q_count is a short on non-eft
	 * systems.
	 */
	u_long	t_qsize;		/* number of data chars on outq */
	/*
	 * here we save mblks that arrive before the connection is accepted
	 * by the user and those received when the user's queue is full. 
	 */
	mblk_t	*t_qfirst;		/* beginning of queued data */
	mblk_t	*t_qlast;		/* end of queued data */
	int	t_iqsize;		/* amount of data on input queue */
	int	t_iqurp;		/* offset of urgent byte on input q */
	mblk_t	*t_inq;			/* pending input */
	short	t_linger;		/* linger flag */
	mblk_t	*t_outq_closed;	/* data on outq when t_inpcb->inp_q is NULL */
#endif /* STRNET */
#if defined(_SMP) && defined(SNI)
	lck_t	t_reasslock;	/* lock for reassembly-queue */
#endif
#if defined(XTI_SUPPORT)
	int     t_keepidle;             /* XTI: idle time for a connection */
	mblk_t  *t_optneg;              /* XTI: option negotiation */
#endif /* defined(XTI_SUPPORT) */

};

#define	intotcpcb(ip)	((struct tcpcb *)(ip)->inp_ppcb)
#ifdef STRNET
#define qtotcpcb(q) ((struct tcpcb *) ((struct inpcb *) (q)->q_ptr)->inp_ppcb)
#else
#define	sototcpcb(so)	(intotcpcb(sotoinpcb(so)))
#endif /* STRNET */

/*
 * TCP statistics.
 * Many of these should be kept per connection,
 * but that's inconvenient at the moment.
 */
struct	tcpstat {
	u_long	tcps_connattempt;	/* connections initiated */
	u_long	tcps_accepts;		/* connections accepted */
	u_long	tcps_connects;		/* connections established */
	u_long	tcps_drops;		/* connections dropped */
	u_long	tcps_conndrops;		/* embryonic connections dropped */
	u_long	tcps_closed;		/* conn. closed (includes drops) */
	u_long	tcps_segstimed;		/* segs where we tried to get rtt */
	u_long	tcps_rttupdated;	/* times we succeeded */
	u_long	tcps_delack;		/* delayed acks sent */
	u_long	tcps_timeoutdrop;	/* conn. dropped in rxmt timeout */
	u_long	tcps_rexmttimeo;	/* retransmit timeouts */
	u_long	tcps_persisttimeo;	/* persist timeouts */
	u_long	tcps_keeptimeo;		/* keepalive timeouts */
	u_long	tcps_keepprobe;		/* keepalive probes sent */
	u_long	tcps_keepdrops;		/* connections dropped in keepalive */

	u_long	tcps_sndtotal;		/* total packets sent */
	u_long	tcps_sndpack;		/* data packets sent */
	u_long	tcps_sndbyte;		/* data bytes sent */
	u_long	tcps_sndrexmitpack;	/* data packets retransmitted */
	u_long	tcps_sndrexmitbyte;	/* data bytes retransmitted */
	u_long	tcps_sndacks;		/* ack-only packets sent */
	u_long	tcps_sndprobe;		/* window probes sent */
	u_long	tcps_sndurg;		/* packets sent with URG only */
	u_long	tcps_sndwinup;		/* window update-only packets sent */
	u_long	tcps_sndctrl;		/* control (SYN|FIN|RST) packets sent */

	u_long	tcps_rcvtotal;		/* total packets received */
	u_long	tcps_rcvpack;		/* packets received in sequence */
	u_long	tcps_rcvbyte;		/* bytes received in sequence */
	u_long	tcps_rcvbadsum;		/* packets received with ccksum errs */
	u_long	tcps_rcvbadoff;		/* packets received with bad offset */
	u_long	tcps_rcvshort;		/* packets received too short */
	u_long	tcps_rcvduppack;	/* duplicate-only packets received */
	u_long	tcps_rcvdupbyte;	/* duplicate-only bytes received */
	u_long	tcps_rcvpartduppack;	/* packets with some duplicate data */
	u_long	tcps_rcvpartdupbyte;	/* dup. bytes in part-dup. packets */
	u_long	tcps_rcvoopack;		/* out-of-order packets received */
	u_long	tcps_rcvoobyte;		/* out-of-order bytes received */
	u_long	tcps_rcvpackafterwin;	/* packets with data after window */
	u_long	tcps_rcvbyteafterwin;	/* bytes rcvd after window */
	u_long	tcps_rcvafterclose;	/* packets rcvd after "close" */
	u_long	tcps_rcvwinprobe;	/* rcvd window probe packets */
	u_long	tcps_rcvdupack;		/* rcvd duplicate acks */
	u_long	tcps_rcvacktoomuch;	/* rcvd acks for unsent data */
	u_long	tcps_rcvackpack;	/* rcvd ack packets */
	u_long	tcps_rcvackbyte;	/* bytes acked by rcvd acks */
	u_long	tcps_rcvwinupd;		/* rcvd window update packets */
	u_long	tcps_linger;		/* connections that lingered */
	u_long	tcps_lingerabort;	/* lingers aborted by signal */
	u_long	tcps_lingerexp;		/* linger timer expired */
	u_long	tcps_lingercan;		/* linger timer cancelled */
};


/*
 * additional statistics for SNMP
 */
struct snmptcpstat {
	int	tcpAttemptFails;	/* 7 */
	int	tcpEstabResets;		/* 8 */
	int	tcpOutRsts;		/* 15 */
};


#ifdef _SMP
#define TCP_PR	0x1D0
#endif /* _SMP */

#ifdef STRNET
#ifdef TLI_PRIMS
char	*tli_primitives[] = {"CONNECT", "ACCEPT", "DISCONNECT", "DATA",
			     "EX_DATA", "INFORMATION", "BIND", "UNBIND",
			     "UNITDATA", "OPTIONS", "ORDERLY RELEASE",
			     };
#endif /* TLI_PRIMS */
#endif /* STRNET */

#ifdef _KERNEL
struct	tcpiphdr *tcp_template();
struct	tcpcb *tcp_close(), *tcp_drop();
struct	tcpcb *tcp_timers(), *tcp_disconnect(), *tcp_usrclosed();
extern	struct inpcb tcb;
extern	struct tcpstat tcpstat;
#endif
#ifdef __sun__
#define TCP_COMPAT_42
#endif
#endif	/* _NETINET_TCP_VAR_H */

