#ident "@(#)$Header: async.h,v 1.9 94/03/30 10:26:29 gold Exp $ SNI"
/*
 * "@(#)async.h	Revision: 2.2	91/05/16 10:29:58"
 */

/*	Copyright (c) 1991 Pyramid Technology	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Pyramid Technology */
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_ASYNC_H
#define _SYS_ASYNC_H

/*
 * Asynchronous disk I/O facility for SVR4.0.3
 */

#include <sys/ioccom.h>

/* AIO version
 * 	Return the version number of the current interface
 *
 * Version must be 3 or greater to support ISTD AIO emulation
 * facility.
 */
/*HG TEMPORAERER Versionsrueckschritt wegen ORACLE Portierung, die
	diesen Wert fest abfragt
*/
#define	AIOVERSION	2

/*#ifdef SNI */
/* we had to do this, because of applications that test for 
   the AIOVERSION constant, and do not want to be recompiled.
   ISTD_AIOVERSION is a new version specification for the 
   Pyramid specific ISTD interface.
*/
#define	ISTD_AIOVERSION	3
#define	DKIOCISTDAIOVERS	_IOR('S', 5, long)
/*#endif SNI */

#define	DKIOCAIOVERS	_IOR('S', 4, long)

/* Starting I/O (DKIOCASTRT)
 *
 *	'S' and '1' define a unique command number.  Using
 *	_IOW specifies that the parameters are for input only.
 *
 *	The parameter passed back to SVR4 is a struct areqbuf.
 */
typedef struct  areqbuf {
	long	au_cmd;			/* AU_READ, etc */
	long	au_daddr;		/* destination on disk */
	char	*au_maddr;		/* (virtual) memory address */
	long	au_size;		/* bytes to transfer */
	char	*au_ref;		/* caller specified reference */
} AREQBUF;

/* command bits
 * Note:  AU_ORDWRITE is treated as AU_WRITE in the kernel
 *	  They exist as separate flags for user convenience only.
 */
#define	AU_READ		01		/* read request */
#define	AU_WRITE	02		/* unordered write request */
#define	AU_ORDWRITE	04		/* ordered write request */
#define	AU_CMDMASK	07		/* mask of command bits */

/* The disk block to transfer to/from is in the lower 3 bytes
 * of au_daddr, the upper byte are ignored by SVR4.
 */
#define	ADBLK(A)	((A) & 0xffffff)

#define	DKIOCASTRT	_IOW('S', 1, AREQBUF)

/* Getting I/O Completion Status (DKIOCSTAT)
 *
 *	'S' and '2' define a unique command number.  Using
 *	_IOR specifies that the parameters are for output only.
 *
 *	The parameter passed back from SVR4 is a struct asyncstatus.
 */

typedef struct aiostat
{
	short	iostatus;		/* I/O completion status for request */
	short	iobsize;		/* verification (from AREQBUF dbsize) */
	char	*iomaddr;		/* verification (from AREQBUF dbmaddr)*/
	char	*ioref;			/* return caller specified reference */
} IOSTAT;

#define	MAXSTATUS	15

typedef struct asyncstatus
{
	long	acount;			/* # of requests being returned */
	IOSTAT	astatus[MAXSTATUS];	/* completion status per request */
} ASYNCSTATUS;

#define	DKIOCASTAT	_IOR('S', 2, ASYNCSTATUS)

/* Locking Memory for I/O (DKIOCMLOCK)
 *
 *	'S' and '3' define a unique command number.  Using
 *	_IOW specifies that the parameters are for input only.
 *
 *	The parameters are passed to SVR4 as a struct asyncmlock.
 */

typedef struct asyncmlock
{
	char	*avaddr;		/* starting virtual address */
	unsigned asize;			/* size of area to be locked */
} ASYNCMLOCK;

#define	DKIOCMLOCK	_IOW('S', 3, ASYNCMLOCK)

/* This is a new I/O error code - it really belongs in errno.h.
 * However, since it is AIO specific, it is here.
 */
#define	EIORESID	500		/* block not (fully) transfered */

#ifdef	_KERNEL
#ifdef	__i386__
struct  aiomap
{
        caddr_t oldaddr;        /* actual user address where I/O started */
        caddr_t newaddr;        /* kernel address I/O job mapped to */
        int npgs;               /* number of pages of I/O job */
        u_int   phys1;          /* physical byte address of I/O job in page1 */
        u_int   phys2;          /* physical byte address of I/O job in page2 */
                                /* phys2 is always physically page aligned */
};
#endif
#endif

#endif /* _SYS_ASYNC_H */
