#ident "@(#)$Header: conf.h,v 1.6 92/10/09 10:33:43 svr4 Exp $ SNI"
/*
 * "@(#)conf.h	Revision: 3.2	92/05/21 16:51:18"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990, 1991 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_CONF_H
#define _SYS_CONF_H

/*#ident	"@(#)ATTDSG usr/src/gencpu/gensys/uts/sys	1.1.2.1"*/

/*
 * Declaration of block device switch. Each entry (row) is
 * the only link between the main unix code and the driver.
 * The initialization of the device switches is in the file conf.c.
 */
struct bdevsw {
	int	(*d_open)();
	int	(*d_close)();
	int	(*d_strategy)();
	int	(*d_print)();
	int	(*d_size)();
	int	(*d_xpoll)();
	int	(*d_xhalt)();
	char	*d_name;
#ifdef __i386__
	struct iobuf	*d_tab;
#endif
	int	*d_flag;
#if defined(mips) && !defined(u3b2v4)
	int	(*d_dump)();
	int	(*d_latency)();
	int	(*d_flush)();
	int	(*d_errcnt)();
	int	(*d_kioctl)();
	int	d_spare[1];
#endif
};

extern struct bdevsw bdevsw[];
extern struct bdevsw shadowbsw[];

/*
 * Character device switch.
 */
struct cdevsw {
	int	(*d_open)();
	int	(*d_close)();
	int	(*d_read)();
	int	(*d_write)();
	int	(*d_ioctl)();
	int	(*d_mmap)();
	int	(*d_segmap)();
	int	(*d_poll)();
	int	(*d_xpoll)();
	int	(*d_xhalt)();
	struct tty *d_ttys;
	struct streamtab *d_str;
	char	*d_name;
	int	*d_flag;
	int	(*d_specaio)();		/* for specaio support */
#if defined(mips) && !defined(u3b2v4)
	int	(*d_kioctl)();
	int	d_spare[1];
#endif
};

extern struct cdevsw cdevsw[];
extern struct cdevsw shadowcsw[];


#ifdef __i386__
/*
 * And the console co routine.  This is declared as
 * a configuration parameter so that it can be changed
 * to match /dev/console.
 */
struct  conssw {
    int (*co)();
    int co_dev;
    int (*ci)();
};

extern struct conssw conssw;
#endif



/*
 * Device flags.
 *
 * Bit 0 to bit 15 are reserved for kernel.
 * Bit 16 to bit 31 are reserved for different machines.
 */
#define D_NEW		0x00	/* new-style driver */
#define	D_OLD		0x01	/* old-style driver */
#define D_DMA		0x02    /* driver does DMA  */
/*
 * Added for UFS.
 */
#define D_SEEKNEG       0x04    /* Negative seek offsets are OK */
#define D_TAPE          0x08    /* Magtape device (no bdwrite when cooked) */
/*
 * Added for pre-4.0 drivers backward compatibility.
 */
#define D_NOBRKUP	0x10	/* No breakup needed for new drivers */
/*
 * Added for gen_breakup()
 */
#define D_PGIOMAP	0x20	/* Map buffer page list into kernel space */
#define D_RAWMAP	0x40	/* Map raw I/O into kernel space */
/*
 * Added for AIO.
 */
#define	D_DISK		0x10000	/* Device is a disk */


#define ROOTFS_NAMESZ	7	/* Maximum length of root fstype name */

#define	FMNAMESZ	8

struct fmodsw {
	char	f_name[FMNAMESZ+1];
	struct streamtab *f_str;
	int	*f_flag;		/* same as device flag */
};
extern struct fmodsw fmodsw[];

extern int	bdevcnt;
extern int	cdevcnt;
extern int	fmodcnt;

/*
 * Line discipline switch.
 */
struct linesw {
	int	(*l_open)();
	int	(*l_close)();
	int	(*l_read)();
	int	(*l_write)();
	int	(*l_ioctl)();
	int	(*l_input)();
	int	(*l_output)();
	int	(*l_mdmint)();
};
extern struct linesw linesw[];

extern int	linecnt;
/*
 * Terminal switch
 */
struct termsw {
	int	(*t_input)();
	int	(*t_output)();
	int	(*t_ioctl)();
};
extern struct termsw termsw[];

extern int	termcnt;

#ifdef mips
/*
* Probe list
*/
struct io_probelist {
	int pl_autotype;		/* autoconf type */
	const int *pl_devtype;		/* device type */
	int (*pl_probe)();		/* address of the probe routine */
	int pl_nhw;			/* number of addresses to probe */
	void *pl_hw;			/* hardware information for probe */
	int pl_unitmult;		/* maximum units for this device */
	int pl_unitbase;		/* base unit number to start with */
};
#endif

#if defined(u3b2) || defined(u3b2v4)
/* 
 * Bubus boards share 3 interrupt levels (10,12,14)
 * interrupt routines are held in this stucture.
 */
struct bubusw {
	int	(*slot0)();
	int	(*slot1)();
	int	(*slot2)();
	int	(*slot3)();
};
extern struct bubusw bubusw[];
extern struct bubusw *bubuswp;


struct bubusop {
	int	(*slot0)();
	int	(*slot1)();
	int	(*slot2)();
	int	(*slot3)();
};
extern struct bubusop bubusop;
extern struct bubusop *bubusopp;
#endif

#ifdef _SMP
/*
 * Replacement for the io_init array.  A non-NULL in_drsp->d_cpuid field
 * indicates a particular processor binding is required.
 * Use compatibility mode if in_drsp->d_flgs has D_STHREAD set.
 */

struct initv {
	int	(*in_func)();	/* function to call */

	/*
	* in_cpuid specifies the processor qualified to execute
	* this handler. This value is never NOCPU to prevent
	* multiple processors from executing the handler simultaneously.
	* This value defaults to 0 (bootcpu). If the associated driver
	* is bound, then this value takes on that bind attribute.
	*/
	cpuid_t	in_cpuid;

	drmp_t	*in_drsp;	/* device driver MP state pointer */
};

extern struct initv	initv[];

/*
 * Replacement for the io_poll array.  Use compatibility mode
 * if the xp_drsp->d_flgs field has D_STHREAD set.
 */

struct xpollv {
	int	(*xp_func)();	/* function to call */

	/*
	* xp_cpuid specifies the processor qualified to execute
	* this handler. This value is never NOCPU to prevent
	* multiple processors from executing the handler simultaneously.
	* This value defaults to 0 (bootcpu). If the associated driver
	* is bound, then this value takes on that bind attribute.
	*/
	cpuid_t	xp_cpuid;

	drmp_t	*xp_drsp;	/* driver MP state pointer */
};

extern struct xpollv	xpollv[];

/*
 * Replacement for the ivect array.  Use compatibility mode
 * if the i_drsp->d_flgs field has D_STHREAD set.
 */

struct intrv {
	int	(*i_func)();	/* function to call */
	drmp_t	*i_drsp;	/* driver MP state pointer */
};

extern struct intrv	intrv[];

/*
 * Replacement for the io_start array.  A non-NULL s_drsp->d_cpuid field
 * indicates a particular processor binding is required.
 * Use compatibility mode if s_drsp->d_flgs has D_STHREAD set.
 */

struct startv {
	int	(*s_func)();	/* function to call */

	/*
	* s_cpuid specifies the processor qualified to execute
	* this handler. This value is never NOCPU to prevent
	* multiple processors from executing the handler simultaneously.
	* This value defaults to 0 (bootcpu). If the associated driver
	* is bound, then this value takes on that bind attribute.
	*/
	cpuid_t	s_cpuid;

	drmp_t	*s_drsp;	/* device driver MP state pointer */
};

extern struct startv	startv[];

/*
 * Replacement for the io_halt array.  A non-NULL h_drsp->d_cpuid field
 * indicates a particular processor binding is required.
 * Use compatibility mode if h_drsp->d_flgs has D_STHREAD set.
 */

struct haltv {
	int	(*h_func)();	/* function to call */

	/*
	* h_cpuid specifies the processor qualified to execute
	* this handler. This value is never NOCPU to prevent
	* multiple processors from executing the handler simultaneously.
	* This value defaults to 0 (bootcpu). If the associated driver
	* is bound, then this value takes on that bind attribute.
	*/
	cpuid_t	h_cpuid;

	drmp_t	*h_drsp;	/* device driver MP state pointer */
};

extern struct haltv	haltv[];

#if defined(__i386__) || defined(mips)
/*
 * Replacement for the io_kenter array.  A non-NULL ken_drsp->d_cpuid field
 * indicates a particular processor binding is required.
 * Use compatibility mode if ken_drsp->d_flgs has D_STHREAD set.
 */

struct kenterv {
	int	(*ken_func)();	/* function to call */

	/*
	* ken_cpuid specifies the processor qualified to execute
	* this handler. This value is never NOCPU to prevent
	* multiple processors from executing the handler simultaneously.
	* This value defaults to 0 (bootcpu). If the associated driver
	* is bound, then this value takes on that bind attribute.
	*/
	cpuid_t	ken_cpuid;

	drmp_t	*ken_drsp;	/* device driver MP state pointer */
};

extern struct kenterv	kenterv[];

/*
 * Replacement for the io_kexit array.  A non-NULL kex_drsp->d_cpuid field
 * indicates a particular processor binding is required.
 * Use compatibility mode if kex_drsp->d_flgs has D_STHREAD set.
 */

struct kexitv {
	int	(*kex_func)();	/* function to call */

	/*
	* kex_cpuid specifies the processor qualified to execute
	* this handler. This value is never NOCPU to prevent
	* multiple processors from executing the handler simultaneously.
	* This value defaults to 0 (bootcpu). If the associated driver
	* is bound, then this value takes on that bind attribute.
	*/
	cpuid_t	kex_cpuid;

	drmp_t	*kex_drsp;	/* device driver MP state pointer */
};

extern struct kexitv	kexitv[];

#endif /* __i386__ || mips */

/*
 * Multiprocessor "shadow" block device switch table.
 * d_xpoll and d_xhalt are not shadowed as they are not reached through
 * system calls.  d_xpoll functions are protected through the xpollv[] table
 * and d_xhalt functions do not need to be protected from concurrency issues.
 * Use compatibility mode if bd_drsp->d_flgs has D_STHREAD set.
 */

struct mp_bdevsw {
	int	(*bd_open)(),
		(*bd_close)(),
		(*bd_strategy)(),
		(*bd_print)(),
		(*bd_size)();
	drmp_t	*bd_drsp;	/* device driver MP state pointer */
};

extern struct mp_bdevsw	mp_bsw[];

/*
 * Multiprocessor "shadow" character device switch table.
 * d_xpoll and d_xhalt are not shadowed as they are not reached through
 * system calls.  d_xpoll functions are protected through the xpollv[] table
 * and d_xhalt functions do not need to be protected from concurrency issues.
 * Use compatibility mode if cd_drsp->d_flgs has D_STHREAD set.
 */

struct mp_cdevsw {
	int	(*cd_open)(),
		(*cd_close)(),
		(*cd_read)(),
		(*cd_write)(),
		(*cd_ioctl)(),
		(*cd_mmap)(),
		(*cd_segmap)(),
		(*cd_poll)(),
		(*cd_specaio)();
	drmp_t	*cd_drsp;	/* device driver MP state pointer */
};

extern struct mp_cdevsw	mp_csw[];

/*
 * Flag for bdevsw[] and cdevsw[] tables to indicate single-threaded drivers.
 */

#define D_STHREAD	0x01
#define D_STREAM	0x02

/*
* return true if target executes in compatibility mode (bound or sema)
*/
#define DDMP_COMPAT(x)	((x) && (((x)->d_cpuid != NOCPU) || ((x)->d_flgs & D_STHREAD)))

/*
* return true if target executes in semaphore compatibility mode
*/
#define DDMP_STHREAD(x)	((x) && ((x)->d_flgs & D_STHREAD))
#define DDMP_SEMA(x)	((x) && ((x)->d_flgs & D_STHREAD))

/*
* return true if target executes in bound compatibility mode
*/
#define DDMP_BIND(x)	((x) && (x)->d_cpuid != NOCPU)

#endif	/* _SMP */

#endif	/* _SYS_CONF_H */
