#ident "@(#) hsmacros.h 1.1 90/01/16 "

/*	Copyright (C) The Santa Cruz Operation, 1989, 1990.	*/

/*	This Module contains Proprietary Information of		*/
/*	The Santa Cruz Operation and should be treated		*/
/*	as Confidential.					*/

						/* BEGIN SCO_FS */
#ifndef	_SYS_FS_HSMACROS_H
#define	_SYS_FS_HSMACROS_H

#ident "$Header: hsmacros.h,v 1.5 92/11/04 15:12:29 reinsch Exp $"

/*
 * High Sierra date and time are stored in one of two
 * possible formats
 *
 * The first format is used in the volume descriptor
 * and has the following structure
 * (all fields except for the timezone are encoded as
 * strings of ASCII characters)
 *
 */
struct hsvtime
{
	char	year[4];	/* 1 - 9999	*/
	char	month[2];	/* 1 - 12	*/
	char	day[2];		/* 1 - 31	*/
	char	hour[2];	/* 0 - 23	*/
	char	min[2];		/* 0 - 60	*/
	char	sec[2];		/* 0 - 59	*/
	char	ten_ms[2];	/* 0 - 99	*/
};

/*
 * The second format is used in extended attribute records
 * and has the following structure
 * (all fields except for the timezone are encoded as
 * 8 bit unsigned binary integers)
 */
struct hsatime
{
	unchar	year;		/* since 1900	*/
	unchar	month;		/* 1 - 12	*/
	unchar	day;		/* 1 - 31	*/
	unchar	hour;		/* 0 - 23	*/
	unchar	min;		/* 0 - 60	*/
	unchar	sec;		/* 0 - 59	*/
};


#define RET_OK			401
#define RET_ERR			402
#define RET_NOT_FOUND	403
#define RET_EOF			404

#define	TRUE	1
#define	FALSE	0

#define FsBSIZE(bsize)		(1024)
#define FsBSHIFT(bsize)		(10)
#define FsBMASK(bsize)		(01777)
#define FsITOD(bsize, x)	(daddr_t)(((unsigned long)(x)) >> FsBSHIFT(bsize))
#define FsITOO(bsize, x)	(ushort)(((unsigned long)(x)) & FsBMASK(bsize))
#define	FsINO(bsize, bno, off)	(ulong)((((unsigned long)(bno)) << FsBSHIFT(bsize)) + off)

#define	STRUCTOFF(structure, field)	(int) &(((struct structure *) 0)->field)

/*
 * macros for accessing binary data in the High Sierra filesystem
 */
#if	__i386__ || i286
#define	getbyte(p)	(*(unchar *)(p))
#define	getword(p)	(*(ushort *)(p))
#define	getdword(p)	(*(ulong *)(p))
#else	/* big endian */
#define	getbyte(p)	(*(unchar *)(p))
#define getword(p) 	((p)[0] + ((p)[1] << 8) ) 
#define getdword(p) ((p)[0] + ((p)[1] << 8) + ((p)[2] << 16) + ((p)[3] << 24)) 
/*
#define getword(p) 	((p)[3] + ((p)[2] << 8) ) 
#define getdword(p) ((p)[7] + ((p)[6] << 8) + ((p)[5] << 16) + ((p)[4] << 24)) 
*/
/*
#define getword(p)      (((ushort *)&(p))[1])
#define getdword(p)     ((((ushort *)&(p))[2] <<16) + ((ushort *)&(p))[3])
*/
#endif

#if 0

/* S5 V4 stuff */

#define FsLTOP(fs, b)	((b) << (fs)->vfs_ltop)
#define FsPTOL(fs, b)	((b) >> (fs)->vfs_ltop)
#define FsITOD(fs, x)	(daddr_t)(((unsigned)(x)+(2*(fs)->vfs_inopb-1)) >> (fs)->vfs_inoshift)
#define FsITOO(fs, x)	(daddr_t)(((unsigned)(x)+(2*(fs)->vfs_inopb-1)) & ((fs)->vfs_inopb-1))
#define FsINOS(fs, x)	((((x) >> (fs)->vfs_inoshift) << (fs)->vfs_inoshift) + 1)

#endif	/* 0 */

#endif	/* _SYS_FS_HSMACROS_H */
						/* END SCO_FS */
