#ident "@(#)hw.h        Revision: 1.7     1/6/91 00:36:10"

/*	Pyramid Technology - Mar 1990	*/
#ifndef hw__h
#define hw__h
#ident	"@(#)hw.h	1.7 :/gw/svr4/sccs/usr/src/mips/mips/uts/sys/mips/s.hw.h 1/6/91 00:36:10"

#ident	"@(#)mips/hw.h	1.7	1/6/91 00:36:10"
#ifndef _SYS_HW_H
#define _SYS_HW_H

/*
 * Masks for setting/checking IPL levels.
 */
#define SR_IMASKNMI	0x00000000		/* default no nmi mask	*/
#define	SR_IMASKALL	0x00000000		/* mask level 8 + NMI 	*/
#define	SR_IMASK8	(0x00000000|SR_IMASKNMI)	/* mask level 8 */
#define	SR_IMASK7	(0x00008000|SR_IMASKNMI)	/* mask level 7 */
#define	SR_IMASK6	(0x0000c000|SR_IMASKNMI)	/* mask level 6 */
#define	SR_IMASK5	(0x0000e000|SR_IMASKNMI)	/* mask level 5 */
#define	SR_IMASK4	(0x0000f000|SR_IMASKNMI)	/* mask level 4 */
#define	SR_IMASK3	(0x0000f800|SR_IMASKNMI)	/* mask level 3 */
#define	SR_IMASK2	(0x0000fc00|SR_IMASKNMI)	/* mask level 2 */
#define	SR_IMASK1	(0x0000fe00|SR_IMASKNMI)	/* mask level 1 */
#define	SR_IMASK0	(0x0000ff00|SR_IMASKNMI)	/* mask level 0 */
#define	SR_IMASKN	0xffff00ff

/* SR_IMASK + SR_IBITn : sbd.h	*/


#ifdef B20R
/*
 * Interrupt Bits in SR (Bits 9-16, Mask 0x0000ff00)
 *
 *       |                                               |
 *       |  16    15    14    13    12    11    10     9 |  8         1
 *    ---+-----+-----+-----+-----+-----+-----+-----+-----+----+-...--+----+
 *       |CLOCK|  -  |  -  |  -  |  -  | IP2 |SOFT1|SOFT0|    |      | IE | 
 *    ---+-----+-----+-----+-----+-----+-----+-----+-----+----+-...--+----+
 *       |                                               |
 *       |                                               |
 *
 *    Interrupt Queueing: currently doesn't use soft interrupt bits (1,2)
 */

#define SR_CLOCK        SR_IBIT8        /* interval timer interrupt */
#define SR_IP2          SR_IBIT3        /* abic (IP2) interrupt */

/*
 * Interrupt Priority Levels (IPL)
 * (machine dependant PLs - Logical PLs map into these)
 *
 * DDI levels (e.g. spl6 == setipl(IPL_6)
 */
#define IPL_NONE                0       /* Used for initializing mplocks */
#define IPL_0           0       /* Allow all interrupts (user mode) */
#define IPL_1           1       /* DDI: context and process switching */
#define IPL_4           20      /* DDI: character devices */
#define IPL_5           21      /* DDI: character devices */
#define IPL_6           21      /* DDI: block devices */
#define IPL_7           24      /* DDI: clock */

#define IPL_STR         21      /* DDI: all streams interrupts */
#define IPL_TTY         21      /* DDI: all tty interrupts */
#define IPL_HI          24      /* DDI: all interrupts */

#define IPL_CPUM        24      /* cpu-to-cpu for cpu hardware monitor
				 * remote func. unilab:020593(RSD)
				 */

#define	IPL_USEC	25	/* cpu-to-cpu for microsecond timer 
				 * synchronisation. This level has to be higher
				 * than the level a function which uses locks
				 * can aquire. (##RSD)
				 */
/*
 * Special low-level-system IPLs
 */

#define IPL_SIGPANIC    29              /* cpu-to-cpu panic message */
#define IPL_SIGSSI      29              /* cpu-to-cpu set software interrupt */
#define IPL_SIGVM       29              /* cpu-to-cpu TLB/Cache flushes */
#define IPL_SIGHALT     30              /* cpu-to-cpu halt message */
#define IPL_SIGDBG      30              /* cpu-to-cpu in debugger message */

#define IPL_PROBECPU    29              /* boot time only */

/*
 * Others
 */
  #define IPL_SOFTCLOCK   5
  #define IPL_SOFTNET     7
  #define IPL_CLOCK       24

#endif

#define	NC0VECS		8
#ifdef _KERNEL
/*
 * Chip interrupt vector
 */
extern	int	(*c0vec_tbl[])();
#endif

#endif /* _SYS_HW_ */
#endif /* hw__h */
