#ident "@(#)$Header: ldterm.h,v 1.5 92/10/09 10:35:04 svr4 Exp $ SNI"
/*
 * "@(#)ldterm.h	Revision: 2.2	91/05/12 15:03:38"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_LDTERM_H
#define _SYS_LDTERM_H

/*#ident	"@(#)gensys:ldterm.h	1.5"*/

#if defined(__i386__) || defined(u3b2)
#include <sys/emap.h>
#endif
#define	IBSIZE	16		/* "standard" input data block size */
#define	OBSIZE	64		/* "standard" output data block size */
#define	EBSIZE	16		/* "standard" echo data block size */

#ifndef MIN
#define	MIN(a,b) (((a)<(b))?(a):(b))
#endif

#define V_MIN 		(char) tp->t_modes.c_cc[VMIN]
#define V_TIME		(char) tp->t_modes.c_cc[VTIME]
#define RAW_MODE	!(tp->t_modes.c_lflag & ICANON)
#define CANON_MODE	(tp->t_modes.c_lflag & ICANON)

/*
 * The following for EUC.
 */

#define EUCSIZE	sizeof(struct eucioc)
#define EUCIN	0	/* copying eucioc_t IN from ioctl */
#define EUCOUT	1	/* copying it OUT to user format */

/*
 * One assumption made throughout this module is:  EUC characters have
 * a display width less than 255.  Also, assumed around, is that they
 * consist of < 256 bytes, but we don't worry much about that.
 */

#define EUC_TWIDTH	255	/* Width of a TAB, as returned by "ldterm_dispwidth" */
#define EUC_BSWIDTH	254	/* Width of a backspace as returned */
#define EUC_NLWIDTH	253	/* newline & cr */
#define EUC_CRWIDTH	252
#define EUC_MAXW	4	/* max display width and memory width, both */
#define EUC_WARNCNT	20	/* # bad EUC erase attempts before hollering */

typedef struct ldterm_mod {
	mblk_t	*t_savbp;	/* saved mblk that holds ld struct */
	struct termios t_modes;	/* Effective modes set by the provider below */
	struct termios t_amodes;/* Apparent modes for user programs */
	struct termios t_dmodes;/* Modes that driver wishes to process */
	unsigned long t_state;	/* internal state of ldterm module */
	int	t_line;		/* output line of tty */
	int	t_col;		/* output column of tty */
	int	t_rocount;	/* number of chars echoed since last output */
	int	t_rocol;	/* column in which first such char appeared */
	mblk_t	*t_message;	/* pointer to first mblk in message being built */
	mblk_t	*t_endmsg;	/* pointer to last mblk in that message */
	int	t_msglen;	/* number of characters in that message */
	mblk_t	*t_echomp;	/* echoed output being assembled */
	int	t_rd_request;   /* Number of bytes requested by M_READ during
				 * vmin/vtime read
				 */
	/*
	 * The following are for EUC processing. 
	 */
	unchar	t_codeset;	/* current code set indicator (read side) */
	unchar	t_eucleft;	/* bytes left to get in current char (read) */
	unchar	t_eucign;	/* bytes left to ignore (output post proc) */
	unchar	t_eucpad;	/* padding ... for eucwioc */
	eucioc_t eucwioc;	/* eucioc structure (have to use bcopy) */
	unchar	*t_eucp;	/* ptr to parallel array of column widths */
	mblk_t	*t_eucp_mp;	/* the m_blk that holds parallel array */
	unchar	t_maxeuc;	/* the max length in memory bytes of an EUC */
	int	t_eucwarn;	/* bad EUC counter */
	int	t_ldterm_tid;	/* local timeout ID for raw mode */
#if defined(__i386__) || defined(u3b2)
	struct emp_tty t_emap;	/* XENIX character mapping info */
#endif
#ifdef mips
	struct riscext t_rext;	/* RISCos compatibility glue */
#endif
	int		t_timer_flags;
	sema_t		t_sema;	/* open/close resource channel */
	lck_t		t_lock;	/* protects t_timer_flags */
	mblk_t		*t_flush;	/* FLUSHW in progress */
	clock_t		t_rtimeout;
	queue_t		*t_rqueue;
	int		t_refs;
} ldtermstd_state_t;

/*
 * Internal state bits.
 */
#define	TS_XCLUDE	0x00000001	/* exclusive-use flag against open */
#define	TS_TTSTOP	0x00000002	/* output stopped by ^S */
#define	TS_TBLOCK	0x00000004	/* input stopped by IXOFF mode */
#define	TS_QUOT		0x00000008	/* last character input was \ */
#define	TS_ERASE	0x00000010	/* within a \.../ for PRTRUB */
#define	TS_SLNCH	0x00000020	/* next character service routine sees is literal */
#define	TS_PLNCH	0x00000040	/* next character put routine sees is literal */

#define TS_TTCR		0x00000080	/* mapping NL to CR-NL */
#define	TS_NOCANON	0x00000100	/* canonicalization done by somebody below us */
#define	TS_RESCAN	0x00000400	/* canonicalization mode changed, rescan input queue */

#define	TS_RTO		0x00000800	/* timer started for vmin/vtime */
#define	TS_TACT		0x00001000	/* timer active for vmin/vtime */
#define TS_MEUC		0x00010000	/* TRUE if multi-byte codesets used */
#define TS_WARNED	0x00020000	/* already warned on console */
#define TS_CLOSE	0x00040000	/* close in progress */

#define TS_DOTIMEIN	0x00080000	/* ##SMP: timer has fired */
/*
 * This is needed to know when we have to send M_START/M_STOP down
 * to the driver without regard to TS_TTSTOP being set or not.
 * If this is set, it essentially means TS_TTSTOP is not a clear
 * indicator of ^S/^Q state, so we must let driver handle it.
 */
#define	TS_DRVIXON	0x00100000	/* driver is doing IXON */


/*
 * Character types.
 */
#define	ORDINARY	0
#define	CONTROL		1
#define	BACKSPACE	2
#define	NEWLINE		3
#define	TAB		4
#define	VTAB		5
#define	RETURN		6

/*
 * The following for EUC handling:
 */
#define T_SS2		7
#define T_SS3		8

/*
 * Table indicating character classes to tty driver.  In particular,
 * if the class is ORDINARY, then the character needs no special
 * processing on output.
 *
 * Characters in the C1 set are all considered CONTROL; this will
 * work with terminals that properly use the ANSI/ISO extensions,
 * but might cause distress with terminals that put graphics in
 * the range 0200-0237.  On the other hand, characters in that
 * range cause even greater distress to other UNIX terminal drivers....
 */

static char typetab[256] = {
/* 000 */ 	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 004 */	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 010 */	BACKSPACE,	TAB,		NEWLINE,	CONTROL,
/* 014 */	VTAB,		RETURN,		CONTROL,	CONTROL,
/* 020 */	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 024 */	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 030 */	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 034 */	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 040 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 044 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 050 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 054 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 060 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 064 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 070 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 074 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 100 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 104 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 110 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 114 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 120 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 124 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 130 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 134 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 140 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 144 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 150 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 154 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 160 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 164 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 170 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 174 */	ORDINARY,	ORDINARY,	ORDINARY,	CONTROL,
/* 200 */ 	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 204 */	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 210 */	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 214 */	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 220 */	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 224 */	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 230 */	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 234 */	CONTROL,	CONTROL,	CONTROL,	CONTROL,
/* 240 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 244 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 250 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 254 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 260 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 264 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 270 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 274 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 300 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 304 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 310 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 314 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 320 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 324 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 330 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 334 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 340 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 344 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 350 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 354 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 360 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 364 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/* 370 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
/*
 * WARNING:  For EUC, 0xFF must be an ordinary character.  It is used with
 * single-byte EUC in some of the "ISO Latin Alphabet" codesets, and occupies
 * a screen position; in those ISO sets where that position isn't used, it
 * shouldn't make any difference.
 */
/* 374 */	ORDINARY,	ORDINARY,	ORDINARY,	ORDINARY,
};

/*
 * Translation table for output without OLCUC.  All ORDINARY-class characters
 * translate to themselves.  All other characters have a zero in the table,
 * which stops the copying.
 */
static unsigned char notrantab[256] = {
/* 000 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 010 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 020 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 030 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 040 */	' ',	'!',	'"',	'#',	'$',	'%',	'&',	'\'',
/* 050 */	'(',	')',	'*',	'+',	',',	'-',	'.',	'/',
/* 060 */	'0',	'1',	'2',	'3',	'4',	'5',	'6',	'7',
/* 070 */	'8',	'9',	':',	';',	'<',	'=',	'>',	'?',
/* 100 */	'@',	'A',	'B',	'C',	'D',	'E',	'F',	'G',
/* 110 */	'H',	'I',	'J',	'K',	'L',	'M',	'N',	'O',
/* 120 */	'P',	'Q',	'R',	'S',	'T',	'U',	'V',	'W',
/* 130 */	'X',	'Y',	'Z',	'[',	'\\',	']',	'^',	'_',
/* 140 */	'`',	'a',	'b',	'c',	'd',	'e',	'f',	'g',
/* 150 */	'h',	'i',	'j',	'k',	'l',	'm',	'n',	'o',
/* 160 */	'p',	'q',	'r',	's',	't',	'u',	'v',	'w',
/* 170 */	'x',	'y',	'z',	'{',	'|',	'}',	'~',	0,
/* 200 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 210 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 220 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 230 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 240 */	(unsigned char)'\240',	(unsigned char)'\241',	(unsigned char)'\242',	(unsigned char)'\243',	(unsigned char)'\244',	(unsigned char)'\245',	(unsigned char)'\246',	(unsigned char)'\247',
/* 250 */	(unsigned char)'\250',	(unsigned char)'\251',	(unsigned char)'\252',	(unsigned char)'\253',	(unsigned char)'\254',	(unsigned char)'\255',	(unsigned char)'\256',	(unsigned char)'\257',
/* 260 */	(unsigned char)'\260',	(unsigned char)'\261',	(unsigned char)'\262',	(unsigned char)'\263',	(unsigned char)'\264',	(unsigned char)'\265',	(unsigned char)'\266',	(unsigned char)'\267',
/* 270 */	(unsigned char)'\270',	(unsigned char)'\271',	(unsigned char)'\272',	(unsigned char)'\273',	(unsigned char)'\274',	(unsigned char)'\275',	(unsigned char)'\276',	(unsigned char)'\277',
/* 300 */	(unsigned char)'\300',	(unsigned char)'\301',	(unsigned char)'\302',	(unsigned char)'\303',	(unsigned char)'\304',	(unsigned char)'\305',	(unsigned char)'\306',	(unsigned char)'\307',
/* 310 */	(unsigned char)'\310',	(unsigned char)'\311',	(unsigned char)'\312',	(unsigned char)'\313',	(unsigned char)'\314',	(unsigned char)'\315',	(unsigned char)'\316',	(unsigned char)'\317',
/* 320 */	(unsigned char)'\320',	(unsigned char)'\321',	(unsigned char)'\322',	(unsigned char)'\323',	(unsigned char)'\324',	(unsigned char)'\325',	(unsigned char)'\326',	(unsigned char)'\327',
/* 330 */	(unsigned char)'\330',	(unsigned char)'\331',	(unsigned char)'\332',	(unsigned char)'\333',	(unsigned char)'\334',	(unsigned char)'\335',	(unsigned char)'\336',	(unsigned char)'\337',
/* 340 */	(unsigned char)'\340',	(unsigned char)'\341',	(unsigned char)'\342',	(unsigned char)'\343',	(unsigned char)'\344',	(unsigned char)'\345',	(unsigned char)'\346',	(unsigned char)'\347',
/* 350 */	(unsigned char)'\350',	(unsigned char)'\351',	(unsigned char)'\352',	(unsigned char)'\353',	(unsigned char)'\354',	(unsigned char)'\355',	(unsigned char)'\356',	(unsigned char)'\357',
/* 360 */	(unsigned char)'\360',	(unsigned char)'\361',	(unsigned char)'\362',	(unsigned char)'\363',	(unsigned char)'\364',	(unsigned char)'\365',	(unsigned char)'\366',	(unsigned char)'\367',
/*
 * WARNING: as for above ISO sets, \377 may be used.  Translate it to
 * itself.
 */
/* 370 */	(unsigned char)'\370',	(unsigned char)'\371',	(unsigned char)'\372',	(unsigned char)'\373',	(unsigned char)'\374',	(unsigned char)'\375',	(unsigned char)'\376',	(unsigned char)'\377',
};

/*
 * Translation table for output with OLCUC.  All ORDINARY-class characters
 * translate to themselves, except for lower-case letters which translate
 * to their upper-case equivalents.  All other characters have a zero in
 * the table, which stops the copying.
 */
static unsigned char lcuctab[256] = {
/* 000 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 010 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 020 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 030 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 040 */	' ',	'!',	'"',	'#',	'$',	'%',	'&',	'\'',
/* 050 */	'(',	')',	'*',	'+',	',',	'-',	'.',	'/',
/* 060 */	'0',	'1',	'2',	'3',	'4',	'5',	'6',	'7',
/* 070 */	'8',	'9',	':',	';',	'<',	'=',	'>',	'?',
/* 100 */	'@',	'A',	'B',	'C',	'D',	'E',	'F',	'G',
/* 110 */	'H',	'I',	'J',	'K',	'L',	'M',	'N',	'O',
/* 120 */	'P',	'Q',	'R',	'S',	'T',	'U',	'V',	'W',
/* 130 */	'X',	'Y',	'Z',	'[',	'\\',	']',	'^',	'_',
/* 140 */	'`',	'A',	'B',	'C',	'D',	'E',	'F',	'G',
/* 150 */	'H',	'I',	'J',	'K',	'L',	'M',	'N',	'O',
/* 160 */	'P',	'Q',	'R',	'S',	'T',	'U',	'V',	'W',
/* 170 */	'X',	'Y',	'Z',	'{',	'|',	'}',	'~',	0,
/* 200 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 210 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 220 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 230 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 240 */	(unsigned char)'\240',	(unsigned char)'\241',	(unsigned char)'\242',	(unsigned char)'\243',	(unsigned char)'\244',	(unsigned char)'\245',	(unsigned char)'\246',	(unsigned char)'\247',
/* 250 */	(unsigned char)'\250',	(unsigned char)'\251',	(unsigned char)'\252',	(unsigned char)'\253',	(unsigned char)'\254',	(unsigned char)'\255',	(unsigned char)'\256',	(unsigned char)'\257',
/* 260 */	(unsigned char)'\260',	(unsigned char)'\261',	(unsigned char)'\262',	(unsigned char)'\263',	(unsigned char)'\264',	(unsigned char)'\265',	(unsigned char)'\266',	(unsigned char)'\267',
/* 270 */	(unsigned char)'\270',	(unsigned char)'\271',	(unsigned char)'\272',	(unsigned char)'\273',	(unsigned char)'\274',	(unsigned char)'\275',	(unsigned char)'\276',	(unsigned char)'\277',
/* 300 */	(unsigned char)'\300',	(unsigned char)'\301',	(unsigned char)'\302',	(unsigned char)'\303',	(unsigned char)'\304',	(unsigned char)'\305',	(unsigned char)'\306',	(unsigned char)'\307',
/* 310 */	(unsigned char)'\310',	(unsigned char)'\311',	(unsigned char)'\312',	(unsigned char)'\313',	(unsigned char)'\314',	(unsigned char)'\315',	(unsigned char)'\316',	(unsigned char)'\317',
/* 320 */	(unsigned char)'\320',	(unsigned char)'\321',	(unsigned char)'\322',	(unsigned char)'\323',	(unsigned char)'\324',	(unsigned char)'\325',	(unsigned char)'\326',	(unsigned char)'\327',
/* 330 */	(unsigned char)'\330',	(unsigned char)'\331',	(unsigned char)'\332',	(unsigned char)'\333',	(unsigned char)'\334',	(unsigned char)'\335',	(unsigned char)'\336',	(unsigned char)'\337',
/* 340 */	(unsigned char)'\340',	(unsigned char)'\341',	(unsigned char)'\342',	(unsigned char)'\343',	(unsigned char)'\344',	(unsigned char)'\345',	(unsigned char)'\346',	(unsigned char)'\347',
/* 350 */	(unsigned char)'\350',	(unsigned char)'\351',	(unsigned char)'\352',	(unsigned char)'\353',	(unsigned char)'\354',	(unsigned char)'\355',	(unsigned char)'\356',	(unsigned char)'\357',
/* 360 */	(unsigned char)'\360',	(unsigned char)'\361',	(unsigned char)'\362',	(unsigned char)'\363',	(unsigned char)'\364',	(unsigned char)'\365',	(unsigned char)'\366',	(unsigned char)'\367',
/*
 * WARNING: as for above ISO sets, \377 may be used.  Translate it to
 * itself.
 */
/* 370 */	(unsigned char)'\370',	(unsigned char)'\371',	(unsigned char)'\372',	(unsigned char)'\373',	(unsigned char)'\374',	(unsigned char)'\375',	(unsigned char)'\376',	(unsigned char)'\377',
};

/*
 * Input mapping table -- if an entry is non-zero, and XCASE is set,
 * when the corresponding character is typed preceded by "\" the escape
 * sequence is replaced by the table value.  Mostly used for
 * upper-case only terminals.
 */
static char	imaptab[256] = {
/* 000 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 010 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 020 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 030 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 040 */	0,	'|',	0,	0,	0,	0,	0,	'`',
/* 050 */	'{',	'}',	0,	0,	0,	0,	0,	0,
/* 060 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 070 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 100 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 110 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 120 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 130 */	0,	0,	0,	0,	'\\',	0,	'~',	0,
/* 140 */	0,	'A',	'B',	'C',	'D',	'E',	'F',	'G',
/* 150 */	'H',	'I',	'J',	'K',	'L',	'M',	'N',	'O',
/* 160 */	'P',	'Q',	'R',	'S',	'T',	'U',	'V',	'W',
/* 170 */	'X',	'Y',	'Z',	0,	0,	0,	0,	0,
/* 200-377 aren't mapped */
};

/*
 * Output mapping table -- if an entry is non-zero, and XCASE is set,
 * the corresponding character is printed as "\" followed by the table
 * value.  Mostly used for upper-case only terminals.
 */
static char	omaptab[256] = {
/* 000 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 010 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 020 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 030 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 040 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 050 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 060 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 070 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 100 */	0,	'A',	'B',	'C',	'D',	'E',	'F',	'G',
/* 110 */	'H',	'I',	'J',	'K',	'L',	'M',	'N',	'O',
/* 120 */	'P',	'Q',	'R',	'S',	'T',	'U',	'V',	'W',
/* 130 */	'X',	'Y',	'Z',	0,	0,	0,	0,	0,
/* 140 */	'\'',	0,	0,	0,	0,	0,	0,	0,
/* 150 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 160 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 170 */	0,	0,	0,	'(',	'!',	')',	'^',	0,
/* 200-377 aren't mapped */
};

/*
 * Translation table for TS_MEUC output without OLCUC.  All printing ASCII
 * characters translate to themselves.  All other _bytes_ have a zero in
 * the table, which stops the copying.  This and the following table exist
 * only so we can use the existing movtuc processing with or without OLCUC.
 * Maybe it speeds up something...because we can copy a block of characters
 * by only looking for zeros in the table.
 *
 * If we took the simple expedient of DISALLOWING "olcuc" with multi-byte
 * processing, we could rid ourselves of both these tables and save 512 bytes;
 * seriously, it doesn't make much sense to use olcuc with multi-byte, and
 * it will probably never be used.  Consideration should be given to disallowing
 * the combination TS_MEUC & OLCUC.
 */
static unsigned char enotrantab[256] = {
/* 000 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 010 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 020 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 030 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 040 */	' ',	'!',	'"',	'#',	'$',	'%',	'&',	'\'',
/* 050 */	'(',	')',	'*',	'+',	',',	'-',	'.',	'/',
/* 060 */	'0',	'1',	'2',	'3',	'4',	'5',	'6',	'7',
/* 070 */	'8',	'9',	':',	';',	'<',	'=',	'>',	'?',
/* 100 */	'@',	'A',	'B',	'C',	'D',	'E',	'F',	'G',
/* 110 */	'H',	'I',	'J',	'K',	'L',	'M',	'N',	'O',
/* 120 */	'P',	'Q',	'R',	'S',	'T',	'U',	'V',	'W',
/* 130 */	'X',	'Y',	'Z',	'[',	'\\',	']',	'^',	'_',
/* 140 */	'`',	'a',	'b',	'c',	'd',	'e',	'f',	'g',
/* 150 */	'h',	'i',	'j',	'k',	'l',	'm',	'n',	'o',
/* 160 */	'p',	'q',	'r',	's',	't',	'u',	'v',	'w',
/* 170 */	'x',	'y',	'z',	'{',	'|',	'}',	'~',	0,
/* 200 - 377 aren't mapped (they're stoppers). */
};

/*
 * Translation table for TS_MEUC output with OLCUC.  All printing ASCII
 * translate to themselves, except for lower-case letters which translate
 * to their upper-case equivalents.  All other bytes have a zero in
 * the table, which stops the copying.  Useless for ISO Latin Alphabet
 * translations, but *sigh* OLCUC is really only defined for ASCII anyway.
 * We only have this table so we can use the existing OLCUC processing with
 * TS_MEUC set (multi-byte mode).  Nobody would ever think of actually
 * _using_ it...would they?
 */
static unsigned char elcuctab[256] = {
/* 000 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 010 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 020 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 030 */	0,	0,	0,	0,	0,	0,	0,	0,
/* 040 */	' ',	'!',	'"',	'#',	'$',	'%',	'&',	'\'',
/* 050 */	'(',	')',	'*',	'+',	',',	'-',	'.',	'/',
/* 060 */	'0',	'1',	'2',	'3',	'4',	'5',	'6',	'7',
/* 070 */	'8',	'9',	':',	';',	'<',	'=',	'>',	'?',
/* 100 */	'@',	'A',	'B',	'C',	'D',	'E',	'F',	'G',
/* 110 */	'H',	'I',	'J',	'K',	'L',	'M',	'N',	'O',
/* 120 */	'P',	'Q',	'R',	'S',	'T',	'U',	'V',	'W',
/* 130 */	'X',	'Y',	'Z',	'[',	'\\',	']',	'^',	'_',
/* 140 */	'`',	'A',	'B',	'C',	'D',	'E',	'F',	'G',
/* 150 */	'H',	'I',	'J',	'K',	'L',	'M',	'N',	'O',
/* 160 */	'P',	'Q',	'R',	'S',	'T',	'U',	'V',	'W',
/* 170 */	'X',	'Y',	'Z',	'{',	'|',	'}',	'~',	0,
/* 200 - 377 aren't mapped (they're stoppers). */
};


#endif	/* _SYS_LDTERM_H */
