#ifdef _KERNEL
#ident "@(#)$Header: map.h,v 1.7 93/02/18 13:19:10 meyeril Locked $ SNI"
/*
 * "@(#)map.h	Revision: 3.3	92/06/01 04:19:44"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990, 1991 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_MAP_H
#define _SYS_MAP_H

/*#ident	"@(#)map.h	3.3"*/

/*
 *		struct map	X[]	.m_size		.m_addr
 *				---	------------	-----------
 *				[0]	mapsize(X)	mapwant(X)
 *					# X[] unused	sleep value
 *
 *		  mapstart(X)->	[1]	# units		unit number
 *				 :	    :		  :
 *				[ ]	    0
 */

struct map
{
	unsigned long m_size;	/* number of units available */
	unsigned long m_addr;	/* address of first available unit */
};

extern struct map sptmap[];	/* Map for system virtual space.   */

/* ##SMP use the second entry to contain the lock */
/* ATTENTION this code relies on the size of lck_t */
#ifdef _SMP
#define	mapstart(X)	&X[2]		/* start of map array */
#else /* _SMP */
#define	mapstart(X)	&X[1]		/* start of map array */
#endif /* _SMP */
#define	mapwant(X)	X[0].m_addr
#define	mapsize(X)	X[0].m_size	/* number of empty slots \
					   remaining in map array */
#ifndef _SMP
#define	mapdata(X) {(X)-2, 0} , {0, 0}
#define	mapinit(X, Y)	X[0].m_size = (Y)-2
#else /* !_SMP */
#if LCK_BEEF_BEVOR > 0
/* locate the lock at the original place,
 * and hope, to do not loose the lock.
 * Do not initialize the dead beef in initspin !!
 */
#define	mapmplock(X)	((lck_t *)((char *)(&X[1]) - LCK_BEEF_BEVOR))
#else /* LCK_BEEF_BEVOR */
#define	mapmplock(X)	((lck_t *)(&X[1]))
#endif /* LCK_BEEF_BEVOR */
#endif /* !_SMP */


#if defined(__STDC__)
extern void rmfree(struct map *, size_t, u_long);
extern void mfree(struct map *, size_t, u_long);
extern u_long rmalloc(struct map *, size_t);
extern u_long malloc(struct map *, size_t);
extern u_long rmalloc_wait(struct map *, size_t);
extern u_long do_rmalloc(struct map *, size_t);
#ifdef _SMP
extern void mapinit(struct map *, size_t);
#endif /* _SMP */
#else
extern void rmfree();
extern void mfree();
extern u_long malloc();
extern u_long rmalloc();
extern u_long rmalloc_wait();
extern u_long do_rmalloc();
#ifdef _SMP
extern void mapinit();
#endif /* _SMP */
#endif

#endif	/* _SYS_MAP_H */
#endif /* defined(_KERNEL) */
