#ident "@(#)$Header: mpinline.h,v 1.4 92/10/09 10:35:24 svr4 Exp $ SNI"
/*
 * "@(#)mpinline.h	Revision: 2.4	91/08/16 16:51:44"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990, 1991 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_MPINLINE_H
#define _SYS_MPINLINE_H

/*#ident	"@(#)ATTDSG gencpu/gensys/uts/sys/mpinline.h	1.1.1.3"*/

#ifdef _SMP
#if !defined(_MPSTATS) && !defined(_LOCKTEST)
#if !defined(ATTSMP) || !defined(CACHEKLUDGE)

#ifdef __i386__

/*
 * Macros for synchronization primitives - this
 * is not for public consumption (i.e. it's
 * not part of DDI).
 */

/*
 * Spin lock `P' operation
 */
asm	void
pspin(lck)
{
%mem		lck; lab pspin_atom; lab pspin_loop; lab pspin_done;
		movl  lck, %edx

pspin_atom:	movl  $1, %eax
		xchgb  %al, (%edx)
		testb $1, %al
		jz    pspin_done
		movl  $MAXWAITTIME, %ecx

pspin_loop:	testb $1, (%edx)
		jz    pspin_atom
		testl $1, locksoff
		jnz   pspin_done
		pushl %ecx
		pushl %edx
		call  backoff_delay
		popl  %edx
		popl  %ecx
		subl  %eax, %ecx
		jnz   pspin_loop
		pushl %edx
		call  catch_deadlock
		popl  %edx
		jmp   pspin_atom
pspin_done:
}


/*
 * Spin lock conditional `P' operation
 */
asm	int
cpspin(lck)
{
%mem		lck; lab cpspin_done;
		movl  lck, %edx
		movl  $1, %eax
		xchgb  %al, (%edx)
		testb $1, %al
		jz    cpspin_done
		testl $1, locksoff
		jz    cpspin_done
		movl  $0, %eax
cpspin_done:
}

#endif	/* __i386__ */

#ifdef u3b2

asm	void
pspin(what)
{
%	mem	what;	lab	ploop1;	lab	ploop2;	lab	pspinexit;

	.set	spin_loop_count, 150

	MOVW	&1, %r0
	MOVW	what, %r2
ploop1: SWAPBI	0(%r2)
	BEB	pspinexit
	MOVW	locksoff, %r1
	BEB	pspinexit
	MOVW	&spin_loop_count, %r1

ploop2:	DECW	%r1
	BNEB	ploop2
	BRB	ploop1
pspinexit:
}

asm	int
cpspin(what)
{
%	mem	what;	lab	cpspinexit;

	MOVW	&1, %r0
	MOVW	what, %r2
	SWAPBI	0(%r2)
	BEB	cpspinexit
	MOVW	locksoff, %r1
	BEB	cpspinexit
	MOVW	&0, %r0
cpspinexit:
}

#endif /* u3b2 */

#ifndef mips
/*
 * NOTE: mips optimizer can re-arrange code to the extent
 *	 that mp protections are lost if vspin is done
 *	 inline.
 */

/*
 * Vspin operation
 */
#define vspin(LCK)  (((lck_t *)(LCK))->l_lock) = 0

#endif

#endif	/* CACHEKLUDGE */

/*
 * Semaphore value
 */
#define	valusema(SEM)	((sema_t *)(SEM))->s_val

/*
 * Vsema operation
 */
#define	vsema(sema)	wsema(sema, NULL, PRMPT)

#endif	/* !_MPSTATS && !_LOCKTEST */

#if defined(__i386__) && !defined(DEBUG)
/*
 * Only make this happen for SMP systems since
 * smaller machines may not have as much memory to burn
 */

extern	int	ipl;

asm	int
splhi()
{
	cli
	movl ipl, %eax 
	movl $SPL_HI, ipl
}

#endif /* !DEBUG && __i386__ */
#endif	/* _SMP */
#endif	/* _SYS_MPINLINE_H */
