#ifndef _SYS_SIGACTION_H
#define _SYS_SIGACTION_H

#ident "@(#)$Header: sigaction.h,v 1.6 94/03/15 15:44:17 isen Exp $ SNI"

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#if (!defined (__STRICT_ANSI__)) || defined(_POSIX_SOURCE) || defined(_XOPEN_SOURCE) || defined(_KERNEL)

#ifndef _SIGACTION_
#define _SIGACTION_

struct sigaction {
	int sa_flags;
	void (*sa_handler)();
	sigset_t sa_mask;
	int sa_resv[2];
};
#endif	/* _SIGACTION_ */

#else /* (!defined (__STRICT_ANSI__))||defined(_POSIX_SOURCE)||defined(_XOPEN_SOURCE) */

#ifndef _SIGACTION_
#define _SIGACTION_

struct __sigaction {
	int __sa_flags;
	void (*__sa_handler)();
	__sigset_t __sa_mask;
	int __sa_resv[2];
};
#endif	/* _SIGACTION_ */

#endif /* (!defined (__STRICT_ANSI__))||defined(_POSIX_SOURCE)||defined(_XOPEN_SOURCE) */

/* definitions for the sa_flags field */

#define SA_ONSTACK	0x00000001
#define SA_RESETHAND	0x00000002
#define SA_RESTART	0x00000004
#define SA_SIGINFO	0x00000008
#define SA_NODEFER	0x00000010

/* these are only valid for SIGCLD */
#define SA_NOCLDWAIT	0x00010000	/* don't save zombie children	 */
#define SA_NOCLDSTOP	0x00020000	/* don't send job control SIGCLD's */

#endif /* _SYS_SIGACTION_H */
