#ident "@(#)$Header: sysinfo.h,v 1.4 92/10/09 10:36:56 svr4 Exp $ SNI"
/*
 * "@(#)sysinfo.h	Revision: 2.3	91/08/30 08:51:25"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990, 1991 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_SYSINFO_H
#define _SYS_SYSINFO_H

/*#ident	"@(#)gensys:sysinfo.h	1.6"*/

/*
 *	System Information.
 */

struct sysinfo {
	time_t	cpu[5];
#define	CPU_IDLE	0
#define	CPU_USER	1
#define	CPU_KERNEL	2
#define	CPU_WAIT	3
#define CPU_SXBRK	4
	time_t	wait[3];
#define	W_IO	0
#define	W_SWAP	1
#define	W_PIO	2
	long	bread;
	long	bwrite;
	long	lread;
	long	lwrite;
	long	phread;
	long	phwrite;
	long	swapin;
	long	swapout;
	long	bswapin;
	long	bswapout;
	long	pswitch;
	long	syscall;
	long	sysread;
	long	syswrite;
	long	sysfork;
	long	sysexec;
	long	runque;
	long	runocc;
	long	swpque;
	long	swpocc;
	long	iget;
	long	namei;
	long	dirblk;
	ulong	readch;
	ulong	writech;
	long	rcvint;
	long	xmtint;
	long	mdmint;
	long	rawch;
	long	canch;
	long	outch;
	long	msg;
	long	sema;
	long	pnpfault;
	long	wrtfault;
    long    s5ipage;
    long    s5inopage;
    long    ufsipage;
    long    ufsinopage;
    long    xxipage;
    long    xxinopage;
	long	sinfo_paff;
	long	sinfo_ints;
	long	int_def;
	ulong	devint;
#ifdef mips
	ulong	cpuint;
	ulong	fpint;
#endif
	long	splck;
	long	wsplck;
	long	kslck;
	long	wkslck;
	ulong	spare[8];
};

extern struct sysinfo sysinfo;
#if defined(__STDC__) && !defined(lint)
 #pragma large_data sysinfo
#endif

/*
 * Syswait structure.  Used to identify idle time spent waiting for
 * several forms of i/o activity.  Before blocking for an I/O event,
 * the appropriate counter is bumped.  On return the count is decremented.
 *  If the system goes idle while a count is non-zero, the system
 * is accounted as being in "iowait" state.
 * SMP:  We want this notion to be "per-cpu" but we have a problem:
 * we may bump the count on one cpu but we awaken on another and
 * decrement his count.  To solve this, we do the following: we bump
 * the count and save (in proc structure) the cpu we are on.
 * When awakened, we decrement the count if still on the
 * same cpu (normally the case).  If on another cpu, we
 * increment the original cpu's "alt" count (using locks
 * to protect the update since that variable can be changed
 * by several cpus).  The actual value of an element is
 * computed as "element - element.alt".
 */
struct syswait {
	int	iowait;
	int	swap;
	int	physio;
	/*
	 * Counts of "decrements" that happened on
	 * another cpu.
	 * Updates to these elements must be protected
	 * with syswait_mplock */
	int	iowait_alt;
	int	swap_alt;
	int	physio_alt;
};

/*
 * Macros used to increment and decrement syswait counts.
 */
#ifdef _SMP

#define SYSWAIT_INCR(element) \
	{ syswait.element++;    \
	  u.u_procp->p_syswaitcpu = lcpunum; \
	}

#define SYSWAIT_DECR(element)				\
	{ if (u.u_procp->p_syswaitcpu == lcpunum)			\
		syswait.element--;					\
	  else	{							\
		int s;							\
		SPL6(s);						\
		PSPIN(&syswait_mplock, &mpsbuf[MPS_SPIN_SYSWAIT]); 	\
		SYSWAIT(u.u_procp->p_syswaitcpu,element##_alt)++;	\
		VSPIN(&syswait_mplock, &mpsbuf[MPS_SPIN_SYSWAIT]);	\
		SPLX(s);						\
	  }							 	\
	}
#else

#define SYSWAIT_INCR(element)			syswait.element++
#define SYSWAIT_DECR(element)			syswait.element--;

#endif  /* _SMP */

struct minfo {
	unsigned long 	freemem[2]; 	/* freemem in pages */
					/* "double" long format	*/
					/* freemem[0] least significant */
	long	freeswap;	/* free swap space */
	long    vfault;  	/* translation fault */
	long    demand;		/*  demand zero and demand fill pages */
	long    swap;		/*  pages on swap */
	long    cache;		/*  pages in cache */
	long    file;		/*  pages on file */
	long    pfault;		/* protection fault */
	long    cw;		/*  copy on write */
	long    steal;		/*  steal the page */
	long    freedpgs;	/* pages are freed */
	long    vfpg; 		/* pages are freed by vhand*/
	long    sfpg;		/* pages are freed by sched*/
	long    vspg;		/* pages are freed/swapped by vhand */
	long    sspg;		/* pages are freed/swapped by sched */
	long    unmodsw;	/* getpages finds unmodified pages on swap */
	long	unmodfl;	/* getpages finds unmodified pages in file */ 
#ifdef	__i386__			/* psk */
	long    psoutok;        /* swapping out a process */
	long    psinfail;       /* swapping in a process failed */
	long    psinok;         /* swapping in a process succeeded */
	long    rsout;          /* swapping out a region */
	long    rsin;           /* swapping in a region */
#endif
	long	shmem;		/* pages used as shmem */
};

typedef struct fsinfo {
	ulong fsireadch;
	ulong fsiwritech;
	ulong fsivop_open;
	ulong fsivop_close;
	ulong fsivop_read;
	ulong fsivop_write;
	ulong fsivop_lookup;
	ulong fsivop_create;
	ulong fsivop_readdir;
	ulong fsivop_getpage;
	ulong fsivop_putpage;
	ulong fsivop_other;
} fsinfo_t;

extern struct minfo minfo;
#if defined(__STDC__) && !defined(lint)
 #pragma large_data minfo
#endif

struct vminfo {
	ulong	v_pgrec;
	ulong	v_xsfrec;
	ulong	v_xifrec;
	ulong	v_pgin;
	ulong	v_pgpgin;
	ulong	v_pgout;
	ulong	v_pgpgout;
	ulong	v_swpout;
	ulong	v_pswpout;
	ulong	v_swpin;
	ulong	v_pswpin;
	ulong	v_dfree;
	ulong	v_scan;
	ulong	v_pfault;
	ulong	v_vfault;
	ulong	v_sftlock;
};

extern struct vminfo vminfo;
#if defined(__STDC__) && !defined(lint)
 #pragma large_data vminfo
#endif

extern struct syswait syswait;
#if defined(__STDC__) && !defined(lint)
 #pragma large_data syswait
#endif 

#ifdef _SMP
extern lck_t  syswait_mplock;
#endif

struct syserr {
	long	inodeovf;	/* s5 inode overflow */
	long	ufsinodeovf;	/* ufs inode overflow */
	long	fileovf;
	long	textovf;
	long	procovf;
};

extern struct syserr syserr;

struct shlbinfo {
	long	shlbs;		/* Max # of libs a process can link in	*/
				/*   at one time.			*/
	long	shlblnks;	/* # of times processes that have used	*/
				/*   static shared libraries.		*/
	long	shlbovf;	/* # of processes needed more shlibs	*/
				/*   than the system imposed limit.	*/
	long	shlbatts;	/* # of times processes have attached	*/
				/*   run time libraries.		*/
};

extern struct shlbinfo shlbinfo;

struct bpbinfo {
	long	usr;		/* usr time for the co-processor	*/
	long	sys;		/* system time for the co-processor	*/
	long	idle;		/* idle time for the co-processor	*/
	long	syscall;	/* # of system calls since boot on the  */
				/*	co-processor			*/
};

extern struct bpbinfo bpbinfo[];

struct rtminfo {
	long	ev_post;		/* # of evpost operations since boot	*/
	long	ev_poll;		/* # of evpoll operations since boot	*/
	long	ev_trap;		/* # of evtrap operations since boot	*/
};
extern struct rtminfo rtminfo;
#if defined(__STDC__) && !defined(lint)
 #pragma large_data rtminfo
#endif

#define KMEM_NCLASS 3		/* # of KMEM request classes		*/
#define KMEM_SMALL  0		/* small KMEM request index		*/
#define KMEM_LARGE  1		/* large KMEM request index		*/
#define KMEM_OSIZE  2		/* outsize KMEM request index		*/

struct kmeminfo {
	ulong	km_mem[KMEM_NCLASS];	/* amount of memory owned by KMEM  */
	ulong	km_alloc[KMEM_NCLASS];  /* amount of memory allocated	   */
	ulong	km_fail[KMEM_NCLASS];	/* # of failed requests		   */
};
extern struct kmeminfo kmeminfo;

#endif	/* _SYS_SYSINFO_H */
