#ident "@(#)$Header: sysmacros.h,v 1.4 92/10/09 10:36:59 svr4 Exp $ SNI"
/*
 * "@(#)sysmacros.h	Revision: 2.4	92/01/29 15:38:45"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990, 1991 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_SYSMACROS_H
#define _SYS_SYSMACROS_H

/*#ident	"@(#)sysmacros.h	2.4"*/

#include <sys/param.h>

/* Core clicks to page tables and vice versa */
/* This is still called ctos, etc to avoid large scale
 * changes in the code. "Segment" here means the
 * memory spanned by a page table.
 */

#ifdef __i386__
#define ctos(x)		(((x) + (NCPPT-1)) >> CPPTSHIFT)
#define	ctost(x)	((x) >> CPPTSHIFT)
#define	stoc(x)		((x) * NCPPT)
#endif
#if defined(u3b2) || defined(mips)
#define ctos(x)		(((x) + (NCPS-1)) >> CPSSHIFT)
#define	ctost(x)	((x) >> CPSSHIFT)
#define	stoc(x)		((x) * NCPS)
#endif

/* Core clicks to segments and vice versa */
#define	ctod(x) ((x)*NDPC)

#ifdef u3b2
/* byte address to segment and vice versa  */
#define sgnum(x)	(((unsigned)(x) >> 17) & 0x1fff)
#define stob(x)		((((unsigned)(x)) & 0x1fff) << 17)
#define	btos(x)		((unsigned)(x) >> 17)
#define secnum(x)	((unsigned)(x) >> 30)

/* Core clicks to immu max offset and vice versa */
#define ctomo(x)	((x) * 256 -1)
#define motoc(x)	((((x)+1)*8) >> BPCSHIFT)
#define motob(x)	(8*((x)+1)-1)
#endif

/*
 * Disk blocks (sectors) and bytes.
 */
#define	dtob(DD)	((unsigned)(DD) << SCTRSHFT)
#define	btod(BB)	((unsigned)((BB) + NBPSCTR - 1) >> SCTRSHFT)
#define	btodt(BB)	((unsigned)(BB) >> SCTRSHFT)

/*
 * Disk blocks (sectors) and pages.
 */
#ifdef u3b2
#define NDPP		4	/* Number of disk blocks per page */
#define DPPSHFT		2	/* Shift for disk blocks per page. */
#else
#define NDPP		8	/* Number of disk blocks per page */
#define DPPSHFT		3	/* Shift for disk blocks per page. */
#endif
#define	ptod(PP)	((PP) << DPPSHFT)
#define	dtop(DD)	(((DD) + NDPP - 1) >> DPPSHFT)
#define dtopt(DD)	((DD) >> DPPSHFT)

/* clicks to bytes */
#ifdef BPCSHIFT
#define	ctob(x)	((x)<<BPCSHIFT)
#else
#define	ctob(x)	((x)*NBPC)
#endif

/* bytes to clicks */
#ifdef BPCSHIFT
#define	btoc(x)	(((unsigned)(x)+(NBPC-1))>>BPCSHIFT)
#define	btoct(x)	((unsigned)(x)>>BPCSHIFT)
#else
#define	btoc(x)	(((unsigned)(x)+(NBPC-1))/NBPC)
#define	btoct(x)	((unsigned)(x)/NBPC)
#endif

/* common macros */

#define MIN(a, b)	((a) < (b) ? (a) : (b))
#define MAX(a, b)	((a) < (b) ? (b) : (a))

/* WARNING: The device number macros defined here should not be used by device 
** drivers or user software. Device drivers should use the device functions
** defined in the DDI/DKI interface (see also ddi.h). Application software should 
** make use of the library routines available in makedev(3). A set of new device 
** macros are provided to operate on the expanded device number format supported
** in SVR4. Macro versions of the DDI device functions are provided for use by
** kernel proper routines only. Macro routines bmajor(), major(), minor(),
** emajor(), eminor(), and makedev() will be removed or their definitions 
** changed at the next major release following SVR4.
*/

#define O_BITSMAJOR	7	/* # of SVR3 major device bits */
#define O_BITSMINOR	8	/* # of SVR3 minor device bits */
#define O_MAXMAJ	0x7f	/* SVR3 max major value */
#define O_MAXMIN	0xff	/* SVR3 max major value */


#define L_BITSMAJOR	14	/* # of SVR4 major device bits */
#define L_BITSMINOR	18	/* # of SVR4 minor device bits */
#ifdef mips
#define L_MAXMAJ	0x3fff	/* Max major value for mips SVR4.
				** The high 4 bits are used to indicate the
				** bus number.  See L_MAXNATIVE below 
				*/
#else
#define L_MAXMAJ	0xff	/* Although 14 bits are reserved, 
				** the 3b2 major number is restricted
				** to 8 bits. 
				*/
#endif

#define L_MAXMIN	0x3ffff	/* MAX minor for 3b2 software drivers.
				** For 3b2 hardware devices the minor is
				** restricted to 256 (0-255)
				*/
#ifdef mips
#define L_BITSBUS	3	/* # of SVR4 bits to determine native bus no */
#define L_MAXNATIVE	0x7	/* MAX number of native buses possible */
#endif

#if defined(_KERNEL) && (defined(u3b2) || defined(u3b2v4))

/* major part of a device internal to the kernel */
#define NMAJORENTRY	256	/* Number of entries in major/minor array */

extern char MAJOR[NMAJORENTRY];
#define	major(x)	(int)(MAJOR[(unsigned)((x)>>O_BITSMINOR) & O_MAXMAJ])
#define	bmajor(x)	(int)(MAJOR[(unsigned)((x)>>O_BITSMINOR) & O_MAXMAJ])

/* get internal major part of expanded device number */

#define getmajor(x) (int)(MAJOR[(unsigned)((x)>>L_BITSMINOR) & L_MAXMAJ])

/* minor part of a device internal to the kernel */
extern char MINOR[256];
#define	minor(x)	(int)(MINOR[(unsigned)((x)>>O_BITSMINOR)&O_MAXMAJ]+((x)&O_MAXMIN))

/* get internal minor part of expanded device number */

#define getminor(x) (int)(MINOR[(unsigned)((x)>>L_BITSMINOR)&L_MAXMAJ]+((x)&L_MAXMIN))

#else

/* major part of a device external from the kernel (same as emajor below) */
#define	major(x)	(int)(((unsigned)x>>O_BITSMINOR)&O_MAXMAJ)
#define	bmajor(x)	(int)(((unsigned)x>>O_BITSMINOR)&O_MAXMAJ)

/* minor part of a device external from the kernel  (same as eminor below)*/
#define	minor(x)	(int)(x&O_MAXMIN)

/* get internal major part of expanded device number */
#define getmajor(x) ((major_t)((x >> L_BITSMINOR) & \
		      (L_MAXMAJ & ~(L_MAXNATIVE << (L_BITSMAJOR-L_BITSBUS)))))

/* get internal minor part of expanded device number */
#define getminor(x)  ((minor_t)(x & L_MAXMIN))

#endif	/* _KERNEL && u3b2 */

/* create old device number */

#define	makedev(x,y)	(unsigned short)(((x)<<O_BITSMINOR) | (y&O_MAXMIN))

/* make an new device number */
			
#define makedevice(x,y)	(unsigned long)(((x)<<L_BITSMINOR) | ((y)&L_MAXMIN))


/*
 *   emajor() allows kernel/driver code to print external major numbers
 *   eminor() allows kernel/driver code to print external minor numbers
 */
#define emajor(x)   (int)((((unsigned long)(x)>>O_BITSMINOR) > O_MAXMAJ) ? \
			NODEV : (((unsigned long)(x)>>O_BITSMINOR)&O_MAXMAJ))
#define eminor(x)	(int)((x)&O_MAXMIN)

/* get external major and minor device 
** components from expanded device number
*/
#ifdef mips		/* mips machines allow for the bus number to be */
			/* part of the major number */

#define getemajor(x)    (int)((((unsigned long)(x)>>L_BITSMINOR) > L_MAXMAJ) ? \
			NODEV : (((unsigned long)(x) >> L_BITSMINOR) & \
			(L_MAXMAJ & ~(L_MAXNATIVE << (L_BITSMAJOR-L_BITSBUS)))))

#else

#define getemajor(x)    (int)((((unsigned long)(x)>>L_BITSMINOR) > L_MAXMAJ) ? \
			NODEV : (((unsigned long)(x)>>L_BITSMINOR)&L_MAXMAJ))

#endif
#define geteminor(x)	(int)((x)&L_MAXMIN)


/* convert to old dev format */

#define cmpdev(x) 	(unsigned long)((((x)>>L_BITSMINOR) > O_MAXMAJ || \
				((x)&L_MAXMIN) > O_MAXMIN) ? NODEV : \
				((((x)>>L_BITSMINOR)<<O_BITSMINOR)|((x)&O_MAXMIN)))

/* convert to new dev format */

#define expdev(x) 	(unsigned long)(((((x)>>O_BITSMINOR)&O_MAXMAJ)<<L_BITSMINOR) \
				| ((x)&O_MAXMIN))

/*
 *  Evaluate to true if the process is an RFS server.
 */
#define	RF_SERVER()	(u.u_procp->p_sysid != 0)

/* machine dependent operations - defined for RFS and STREAMS */

#ifdef	pdp11
#define	SALIGN(p)		(char *)(((int)p+1) & ~1)
#define	IALIGN(p)		(char *)(((int)p+1) & ~1)
#define LALIGN(p)		(char *)(((int)p+1) & ~3)
#endif
#if	__vax__ | __i386__
#define	SALIGN(p)		(char *)(((int)p+1) & ~1)
#define	IALIGN(p)		(char *)(((int)p+3) & ~3)
#define	LALIGN(p)		(char *)(((int)p+3) & ~3)
#endif
#ifdef	u3b2
#define	SALIGN(p)		(char *)(((int)p+1) & ~1)
#define	IALIGN(p)		(char *)(((int)p+3) & ~3)
#define	LALIGN(p)		(char *)(((int)p+3) & ~3)
#endif
#ifdef	mips
#define	SALIGN(p)		(char *)(((int)p+1) & ~1)
#define	IALIGN(p)		(char *)(((int)p+1) & ~3)
#define LALIGN(p)		(char *)(((int)p+1) & ~3)
#endif

#define SNEXT(p)		(char *)((int)p + sizeof (short))
#define INEXT(p)		(char *)((int)p + sizeof (int))
#define LNEXT(p)		(char *)((int)p + sizeof (long))

/*
 * Macros for counting and rounding.
 */
#define howmany(x, y)	(((x)+((y)-1))/(y))
#define roundup(x, y)	((((x)+((y)-1))/(y))*(y))

/*
 * bcd macros -- these macros only operate on 2 bcd digits (8 bits)
 */

#define bcd_to_dec(x)	(  ((((x) >> 4) & 0xf) * 10) + ((x) & 0xf)  )
#define dec_to_bcd(x)	(  (((x) / 10) << 4) | ((x) % 10)  )

#ifndef min
#define min(a, b)   ((a) < (b) ? (a) : (b))
#define umin(a, b)   ((unsigned)(a) < (unsigned)(b) ? (unsigned)(a) : (unsigned)(b))
#endif
#ifndef max
#define max(a, b)   ((a) < (b) ? (b) : (a))
#endif

#endif	/* _SYS_SYSMACROS_H */
